import { MarkerSeries } from "./MarkerSeries";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { ScatterAxisInfoCache } from "./ScatterAxisInfoCache";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Series } from "./Series";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CollisionAvoidanceType } from "./CollisionAvoidanceType";
import { Axis } from "./Axis";
import { ScatterItemSearchMode } from "./ScatterItemSearchMode";
import { ScatterErrorBarSettings } from "./ScatterErrorBarSettings";
import { HighlightingInfo } from "./HighlightingInfo";
import { ScatterFrame } from "./ScatterFrame";
import { SeriesView } from "./SeriesView";
import { Point, Type } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Rect } from "igniteui-react-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { OwnedPoint } from "./OwnedPoint";
import { AxisRange } from "./AxisRange";
import { HashPool$2 } from "igniteui-react-core";
import { MarkerManagerBase } from "./MarkerManagerBase";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Thickness } from "igniteui-react-core";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { Size } from "igniteui-react-core";
import { AssigningScatterStyleEventArgs } from "./AssigningScatterStyleEventArgs";
import { AssigningScatterMarkerStyleEventArgs } from "./AssigningScatterMarkerStyleEventArgs";
import { AssigningSeriesStyleEventArgsBase } from "./AssigningSeriesStyleEventArgsBase";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { ErrorBarsHelper } from "./ErrorBarsHelper";
import { IErrorBarCalculator } from "igniteui-react-core";
import { PathGeometry } from "igniteui-react-core";
import { RenderSurface } from "./RenderSurface";
import { IDictionary$2 } from "igniteui-react-core";
import { ValueLayerValueMode } from "./ValueLayerValueMode";
import { AssigningSeriesShapeStyleEventArgsBase } from "./AssigningSeriesShapeStyleEventArgsBase";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class ScatterBase extends MarkerSeries implements ISupportsErrorBars, ITrendLineSeries {
    static $t: Type;
    protected cg(): SeriesView;
    ng(): void;
    o0(a: SeriesView): void;
    vv: ScatterBaseView;
    protected get_e9(): boolean;
    ag(): Axis[];
    ju(a: any, b: string): any;
    ds(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number): boolean;
    protected bx(): SeriesHitTestMode;
    tu(a: Point): Rect;
    f4(a: Point, b: boolean): boolean;
    constructor();
    vu: ScatterAxisInfoCache;
    xAxis: NumericXAxis;
    yAxis: NumericYAxis;
    xl: string;
    get wa(): IFastItemColumn$1<number>;
    set wa(a: IFastItemColumn$1<number>);
    private v8;
    xt: string;
    get wb(): IFastItemColumn$1<number>;
    set wb(a: IFastItemColumn$1<number>);
    private v9;
    w5: string;
    w7: string;
    protected fn(): boolean;
    protected wp(): boolean;
    protected g0(): List$1<SeriesLayerPropertyOverlay>;
    private xz;
    private x0;
    xh: string;
    xp: string;
    xj: string;
    xr: string;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get y9(): Brush;
    set y9(a: Brush);
    static readonly yk: DependencyProperty;
    trendLineThickness: number;
    zb: PenLineCap;
    za: DoubleCollection;
    trendLinePeriod: number;
    vm: CollisionAvoidanceType;
    get GetErrorBarsXAxis(): Axis;
    get GetErrorBarsYAxis(): Axis;
    w2: number;
    w1: number;
    v6: ScatterItemSearchMode;
    w0: number;
    ob(): void;
    vw: ScatterErrorBarSettings;
    protected o8(a: any, b: string, c: any, d: any): void;
    protected wm(): boolean;
    protected wl(): boolean;
    wg(a: any): boolean;
    wf(a: any): boolean;
    private yi;
    private zc;
    private zd;
    private xv;
    protected wk(a: string, b: FastItemsSourceEventAction): boolean;
    protected no(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    x9(a: ScatterFrame): void;
    ya(a: ScatterFrame, b: Clipper): void;
    aq(a: Axis): AxisRange;
    jr(a: Point): any;
    private v3;
    get v4(): ScatterItemSearchMode;
    set v4(a: ScatterItemSearchMode);
    protected v5(): ScatterItemSearchMode;
    i8(a: Point): number;
    hv(a: Point): number;
    protected ww(a: Point): number;
    private vf;
    private vg;
    protected wv(a: Point): number;
    private xy;
    protected get_wj(): boolean;
    protected get wj(): boolean;
    private wz;
    protected wy(a: Point): number;
    protected wx(a: Point): number;
    th(a: Point, b: boolean, c: boolean): Point;
    fo(a: any): boolean;
    protected qm(a: Rect, b: Rect): void;
    protected qn(a: Rect, b: Rect): void;
    v0: ScatterFrame;
    v2: ScatterFrame;
    vy: ScatterFrame;
    vz(): ScatterFrame;
    xw(a: ScatterBaseView, b: ScatterFrame, c: number, d: Rect, e: Rect): void;
    x6(a: ScatterFrame, b: ScatterBaseView): void;
    nj(a: boolean, b: SeriesView): void;
    wi: boolean;
    wh: boolean;
    protected we: boolean;
    protected wd: boolean;
    protected get_es(): boolean;
    private vq;
    private vr;
    protected vo(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected vp(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    ty(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    protected vn(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    ax(a: any, b: Point, c: boolean): HighlightingInfo;
    ay(a: any, b: Point, c: boolean): HighlightingInfo;
    assigningScatterStyle: (sender: any, args: AssigningScatterStyleEventArgs) => void;
    assigningScatterMarkerStyle: (sender: any, args: AssigningScatterMarkerStyleEventArgs) => void;
    protected wo(): boolean;
    protected wn(): boolean;
    yh(a: ScatterFrame, b: ScatterBaseView): void;
    vi(a: number, b: number): any[];
    protected vj(a: number, b: number): any[];
    protected v7: ScatterSeriesRenderManager;
    xx(a: ScatterBaseView, b: ScatterFrame): void;
    protected x2(a: number, b: number, c: boolean): void;
    protected x1(a: number, b: number, c: boolean): void;
    protected yc(a: AssigningScatterStyleEventArgs): void;
    protected yb(a: AssigningScatterMarkerStyleEventArgs): void;
    x4(a: ScatterFrame, b: ScatterBaseView): void;
    x7(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    x5(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    x3(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: any, e: number, f: number, g: boolean): {
        p4?: number;
        p5?: number;
    };
    x8(a: ErrorBarsHelper, b: IErrorBarCalculator, c: number, d: number, e: number, f: boolean): {
        p2?: number;
        p3?: number;
        p4?: number;
    };
    ye(a: ScatterFrame, b: ScatterBaseView): void;
    private yf;
    private yg;
    gl(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    pq(a: boolean): void;
    protected qd(): void;
    v1: ScatterFrame;
    pr(a: Rect, b: RenderSurface): void;
    private vx;
    po(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    yd(a: IDictionary$2<any, OwnedPoint>, b: HashPool$2<any, Marker>): void;
    vh(a: ScatterBaseView, b: HashPool$2<any, Marker>, c: Point[], d: Rect, e: Rect): Point[];
    wq(a: HashPool$2<any, Marker>, b: List$1<number>): List$1<number>;
    protected n1(a: any): void;
    h2(): number;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    private wc;
    private wr;
    private ws;
    wt: number;
    wu: number;
    private yj;
    ic(a: ValueLayerValueMode, b: Axis): number;
    am(a: ValueLayerValueMode): number[];
    tl(a: number[]): Point;
    tk(a: ValueLayerValueMode): Point;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ScatterSeriesRenderManager extends SeriesRenderManager {
    static $t: Type;
    protected c(): AssigningSeriesStyleEventArgsBase;
    protected a(): AssigningSeriesShapeStyleEventArgsBase;
    aw: AssigningScatterMarkerStyleEventArgs;
    ax: AssigningScatterStyleEventArgs;
    ay(a: ScatterBase, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    az(a: Series, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    a0(a: AssigningSeriesStyleEventArgsBase, b: number, c: number, d: boolean): void;
}
/**
 * @hidden
 */
export declare class ScatterBaseView extends MarkerSeriesView {
    static $t: Type;
    cy: MarkerManagerBase;
    protected cw: Point[];
    protected cz: ScatterBase;
    protected c4: List$1<number>;
    constructor(a: ScatterBase);
    private df;
    private dg;
    c0: ScatterTrendLineManager;
    au(): void;
    private de;
    dh(a: Marker): Size;
    protected cx(): MarkerManagerBase;
    protected dc(a: IDictionary$2<any, OwnedPoint>): void;
    c3(): List$1<Marker>;
    cv(): Point[];
    protected cu(): Point[];
    protected c2(): List$1<number>;
    c5(): void;
    da(a: PathGeometry): void;
    c6(): void;
    db(a: PathGeometry): void;
    dd(): void;
    c1: HashPool$2<any, Marker>;
    ci(a: (arg1: Marker) => void): void;
    c8(a: (arg1: Marker) => void): void;
    c9(): void;
    protected a7(a: RenderingContext, b: boolean): void;
    c7(a: boolean): void;
    getDefaultTooltipTemplate(): string;
}
